/*
  TCP Protocol
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <errno.h>

#include <sys/types.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>

#include <project3/include/pbuf.h>
#include <project3/include/kernel.h>  
#include <project3/include/systm.h>  
#include <project3/include/ksocket.h>

#include "tcp.h"
#include <project3/include/global.h>

static int tcp_socket(struct socket *sock);
static int tcp_bind(struct socket *sock, const struct sockaddr_in *addr);
static int tcp_accept(struct socket *sock, struct sockaddr_in *from);
static int tcp_connect(struct socket *sock, const struct sockaddr_in * to);
static int tcp_close(struct socket *sock);
static int tcp_write(struct socket *sock, const char *buf, int buflen);
static int tcp_read(struct socket *sock, char *buf, int buflen);

static struct transport_proto proto_tcp = {
    .domain     = AF_INET,
    .type       = SOCK_STREAM,

    .socket     = tcp_socket,
    .close      = tcp_close,
    .bind       = tcp_bind,

    .connect    = tcp_connect,
    .accept     = tcp_accept,
    .write      = tcp_write,

    .read       = tcp_read,

    .sendto     = NULL,
    .recvfrom   = NULL,
    .setsockopt = NULL,
};

void tcp_init()
{
    sock_register_transport(&proto_tcp);
}

static int tcp_socket(struct socket *sock) 
{
  return -ENOTSUP;
}

static int tcp_bind(struct socket *sock, const struct sockaddr_in *addr) 
{
  return -ENOTSUP;
}

static int tcp_accept(struct socket *sock, struct sockaddr_in *from) 
{
  return -ENOTSUP;
}

static int tcp_connect(struct socket *sock, const struct sockaddr_in * to) 
{
  return -ENOTSUP;
}

static int tcp_close(struct socket *sock) 
{
  return -ENOTSUP;
}

static int tcp_write(struct socket *sock, const char *buf, int buflen)
{
  return -ENOTSUP;
}

static int tcp_read(struct socket *sock, char *buf, int buflen) 
{
  return -ENOTSUP;
}

/* return -ENOTSUP if an error occurs (socket not found) */
/* called from IP layer  when a packet is received*/
int tcp_receive(struct pbuf* pkt,
		struct in_addr src_addr, 
		struct in_addr dst_addr)
{
  return -ENOTSUP;
}
