#ifndef INCLUDE_TCP_H
#define INCLUDE_TCP_H

#include <sys/types.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>

#include <project3/include/types.h>
#include <project3/include/pbuf.h>
#include <project3/include/hdrdefs.h>

#include "tcp_fsm.h"

void tcp_init();

int tcp_receive(struct pbuf*, struct in_addr, struct in_addr);

#define hz              2       /* 500ms timer grandularity */
#define TCPTV_REXMT     (3*hz)  /* max allowable REXMT value, 3sec */
#define TCPTV_MSL       (30*hz) /* max seg lifetime, 30 sec */
#define TCPTV_KEEP_INIT (75*hz) /* initial connect keepalive, 75 sec */
#define TCP_MAXRXTSHIFT 12      /* maximum retransmits */

#define TCPT_REXMT      0
#define TCPT_PERSIST    1
#define TCPT_KEEP       2
#define TCPT_2MSL       3

/*
 * The size of the TCP send buffer and receive buffer
 */
#define TCP_SNDBUF_SIZE 16
#define TCP_RCVBUF_SIZE 16

#endif /* INCLUDE_TCP_H */
